Package org.apache.sis.metadata.iso.content

## Class DefaultCoverageDescription

- Object
- - AbstractMetadata
  - - ModifiableMetadata
    - - ISOMetadata
      - - AbstractContentInformation
        - - DefaultCoverageDescription

- All Implemented Interfaces:
    `Serializable`, `Emptiable`, `LenientComparable`, `IdentifiedObject`, `ContentInformation`, `CoverageDescription`
  Direct Known Subclasses:
    `DefaultImageDescription`

      public class DefaultCoverageDescription
      extends AbstractContentInformation
      implements CoverageDescription

  Information about the content of a grid data cell. The following property is mandatory in a well-formed metadata according ISO 19115:
  `MD_CoverageDescription` `└─attributeDescription……` Description of the attribute described by the measurement value.

  Limitations:

  - Instances of this class are not synchronized for multi-threading. Synchronization, if needed, is caller's responsibility.
  - Serialized objects of this class are not guaranteed to be compatible with future Apache SIS releases. Serialization support is appropriate for short term storage or RMI between applications running the same version of Apache SIS. For long term storage, use `XML` instead.
  Since:
    0.3
  See Also:
    Serialized Form

  Defined in the `sis-metadata` module

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class ModifiableMetadata

      `ModifiableMetadata​.State`

  - ### Field Summary

    - ### Fields inherited from class ISOMetadata

      `identifiers`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `DefaultCoverageDescription()` | Constructs an empty coverage description.
    `DefaultCoverageDescription​(CoverageDescription object)` | Constructs a new instance initialized with the values from the specified metadata object.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static DefaultCoverageDescription` | `castOrCopy​(CoverageDescription object)` | Returns a SIS metadata implementation with the values of the given arbitrary implementation.
    `RecordType` | `getAttributeDescription()` | Returns the description of the attribute described by the measurement value.
    `Collection<DefaultAttributeGroup>` | `getAttributeGroups()` | Returns information on attribute groups of the resource.
    `CoverageContentType` | `getContentType()` | Deprecated. As of ISO 19115:2014, moved to `DefaultAttributeGroup​.getContentTypes()`.
    `Collection<RangeDimension>` | `getDimensions()` | Deprecated. As of ISO 19115:2014, moved to `DefaultAttributeGroup​.getAttributes()`.
    `Identifier` | `getProcessingLevelCode()` | Returns an identifier for the level of processing that has been applied to the resource, or `null` if none.
    `Collection<RangeElementDescription>` | `getRangeElementDescriptions()` | Provides the description of the specific range elements of a coverage.
    `void` | `setAttributeDescription​(RecordType newValue)` | Sets the description of the attribute described by the measurement value.
    `void` | `setAttributeGroups​(Collection<? extends DefaultAttributeGroup> newValues)` | Sets information on attribute groups of the resource.
    `void` | `setContentType​(CoverageContentType newValue)` | Deprecated. As of ISO 19115:2014, moved to `DefaultAttributeGroup​.setContentTypes(Collection)`.
    `void` | `setDimensions​(Collection<? extends RangeDimension> newValues)` | Deprecated. As of ISO 19115:2014, moved to `DefaultAttributeGroup​.setAttributes(Collection)`.
    `void` | `setProcessingLevelCode​(Identifier newValue)` | Sets the identifier for the level of processing that has been applied to the resource.
    `void` | `setRangeElementDescriptions​(Collection<? extends RangeElementDescription> newValues)` | Sets the description of the specific range elements of a coverage.

    - ### Methods inherited from class AbstractContentInformation

      `castOrCopy`

    - ### Methods inherited from class ISOMetadata

      `getIdentifier, getIdentifierMap, getIdentifiers, getStandard, setIdentifier, transitionTo`

    - ### Methods inherited from class ModifiableMetadata

      `checkWritePermission, checkWritePermission, collectionType, copyCollection, copyList, copyMap, copySet, freeze, isModifiable, nonNullCollection, nonNullList, nonNullMap, nonNullSet, singleton, state, unmodifiable, writeCollection, writeList, writeMap, writeSet`

    - ### Methods inherited from class AbstractMetadata

      `asMap, asTreeTable, equals, equals, getInterface, hashCode, isEmpty, prune, toString`

    - ### Methods inherited from class Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### DefaultCoverageDescription

          public DefaultCoverageDescription()

      Constructs an empty coverage description.

    - #### DefaultCoverageDescription

          public DefaultCoverageDescription​(CoverageDescription object)

      Constructs a new instance initialized with the values from the specified metadata object. This is a shallow copy constructor, since the other metadata contained in the given object are not recursively copied.
      Parameters:
        `object` - the metadata to copy values from, or `null` if none.
      See Also:
        `castOrCopy(CoverageDescription)`

  - ### Method Detail

    - #### castOrCopy

          public static DefaultCoverageDescription castOrCopy​(CoverageDescription object)

      Returns a SIS metadata implementation with the values of the given arbitrary implementation. This method performs the first applicable action in the following choices:
      - If the given object is `null`, then this method returns `null`.
      - Otherwise if the given object is an instance of `ImageDescription`, then this method delegates to the `castOrCopy(…)` method of the corresponding SIS subclass.
      - Otherwise if the given object is already an instance of `DefaultCoverageDescription`, then it is returned unchanged.
      - Otherwise a new `DefaultCoverageDescription` instance is created using the copy constructor and returned. Note that this is a shallow copy operation, since the other metadata contained in the given object are not recursively copied.
      Parameters:
        `object` - the object to get as a SIS implementation, or `null` if none.
      Returns:
        a SIS implementation containing the values of the given object (may be the given object itself), or `null` if the argument was null.

    - #### getAttributeDescription

          public RecordType getAttributeDescription()

      Returns the description of the attribute described by the measurement value.
      Specified by:
        `getAttributeDescription` in interface `CoverageDescription`
      Returns:
        description of the attribute.

    - #### setAttributeDescription

          public void setAttributeDescription​(RecordType newValue)

      Sets the description of the attribute described by the measurement value.
      Parameters:
        `newValue` - the new attribute description.

    - #### getProcessingLevelCode

          @UML(identifier="processingLevelCode",
               obligation=OPTIONAL,
               specification=ISO_19115)
          public Identifier getProcessingLevelCode()

      Returns an identifier for the level of processing that has been applied to the resource, or `null` if none. For image descriptions, this is the image distributor's code that identifies the level of radiometric and geometric processing that has been applied.
      Returns:
        identifier for the level of processing that has been applied to the resource, or `null` if none.
      Since:
        0.5

    - #### setProcessingLevelCode

          public void setProcessingLevelCode​(Identifier newValue)

      Sets the identifier for the level of processing that has been applied to the resource.
      Parameters:
        `newValue` - the new identifier for the level of processing.
      Since:
        0.5

    - #### getAttributeGroups

          @UML(identifier="attributeGroup",
               obligation=OPTIONAL,
               specification=ISO_19115)
          public Collection<DefaultAttributeGroup> getAttributeGroups()

      Returns information on attribute groups of the resource.
      Upcoming API change — generalization
      The element type will be changed to the `AttributeGroup` interface when GeoAPI will provide it (tentatively in GeoAPI 3.1).
      Returns:
        information on attribute groups of the resource.
      Since:
        0.5

    - #### setAttributeGroups

          public void setAttributeGroups​(Collection<? extends DefaultAttributeGroup> newValues)

      Sets information on attribute groups of the resource.
      Upcoming API change — generalization
      The element type will be changed to the `AttributeGroup` interface when GeoAPI will provide it (tentatively in GeoAPI 3.1).
      Parameters:
        `newValues` - the new information on attribute groups of the resource.
      Since:
        0.5

    - #### getContentType

          @Deprecated
          public CoverageContentType getContentType()

      Deprecated.
      As of ISO 19115:2014, moved to `DefaultAttributeGroup​.getContentTypes()`.
      Returns the type of information represented by the cell value. This method fetches the value from the attribute groups.
      Specified by:
        `getContentType` in interface `CoverageDescription`
      Returns:
        type of information represented by the cell value, or `null`.

    - #### setContentType

          @Deprecated
          public void setContentType​(CoverageContentType newValue)

      Deprecated.
      As of ISO 19115:2014, moved to `DefaultAttributeGroup​.setContentTypes(Collection)`.
      Sets the type of information represented by the cell value. This method stores the value in the first writable attribute groups.
      Parameters:
        `newValue` - the new content type.

    - #### getDimensions

          @Deprecated
          public final Collection<RangeDimension> getDimensions()

      Deprecated.
      As of ISO 19115:2014, moved to `DefaultAttributeGroup​.getAttributes()`.
      Returns the information on the dimensions of the cell measurement value. This method fetches the values from the first attribute groups.
      Specified by:
        `getDimensions` in interface `CoverageDescription`
      Returns:
        dimensions of the cell measurement value.

    - #### setDimensions

          @Deprecated
          public void setDimensions​(Collection<? extends RangeDimension> newValues)

      Deprecated.
      As of ISO 19115:2014, moved to `DefaultAttributeGroup​.setAttributes(Collection)`.
      Sets the information on the dimensions of the cell measurement value. This method stores the values in the attribute groups.
      Parameters:
        `newValues` - the new dimensions.

    - #### getRangeElementDescriptions

          public Collection<RangeElementDescription> getRangeElementDescriptions()

      Provides the description of the specific range elements of a coverage.
      Specified by:
        `getRangeElementDescriptions` in interface `CoverageDescription`
      Returns:
        description of the specific range elements of a coverage.

    - #### setRangeElementDescriptions

          public void setRangeElementDescriptions​(Collection<? extends RangeElementDescription> newValues)

      Sets the description of the specific range elements of a coverage.
      Parameters:
        `newValues` - the new range element description.